
var connectionManager = angular.module('connection-manager', []);

connectionManager.service("connectionsvc", ['cookiesvc', '$http', '$rootScope', '$location',
    function(cookiesvc, $http, $rootScope, $location) {

    this.connect =  function(credentials, connectionObject) {
        var url = "/portal/api/remote-rest.php?cmd=login";

        var payload = credentials;
        payload['remoteREST'] = { "address": connectionObject.address };
        var request = {
            method: 'POST',
            url: url,
            data: payload
        };
        return $http(request)
            .then(function(result) {
                var data = result.data;
                $rootScope.managedAppliance.AuthToken  = data.auth_token;
                $rootScope.managedAppliance.hostname = connectionObject.hostname;
                $rootScope.managedAppliance.address = connectionObject.address;
                cookiesvc.put('managedAppliance.AuthToken', $rootScope.managedAppliance.AuthToken);
                cookiesvc.put('managedAppliance.hostname', $rootScope.managedAppliance.hostname);
                cookiesvc.put('managedAppliance.address', $rootScope.managedAppliance.address);
                return result;
            }, function(result) {
                console.log('error on connect');
                result.error = true;
                return result;
            });
    };

    this.disconnect = function(){
        var request = this.createApplianceRequest("/api/logout", "POST", { 'cookie': $rootScope.managedAppliance.AuthToken });
        $http(request)
            .then(function(result) {
                $rootScope.managedAppliance.AuthToken = "";
                $rootScope.managedAppliance.hostname = "";
                $rootScope.managedAppliance.address = "";
                cookiesvc.put('managedAppliance.AuthToken', $rootScope.managedAppliance.AuthToken);
                cookiesvc.put('managedAppliance.hostname', $rootScope.managedAppliance.hostname);
                cookiesvc.put('managedAppliance.address', $rootScope.managedAppliance.address);
                // Move the user from the jobs tab if they are on it.
                var locationPath = $location.path();
                if (locationPath.indexOf('jobs') !== -1) {
                    $location.path('/');
                }
            });
    };

    this.createApplianceRequest = function(remoteURL, remoteMethod, data) {
        var url = "/portal/api/remote-rest.php";
        var payload = data || {};
        payload['remoteREST'] = this.createRemotePayload(remoteURL, remoteMethod);

        return {
            method: "PUT",
            url: url,
            data: payload
        };
    };

    this.createRemotePayload = function(remoteURL, remoteMethod) {
        var method = remoteMethod || "GET";
        return {
            "address": $rootScope.managedAppliance.address,
            "url": remoteURL,
            "auth": $rootScope.managedAppliance.AuthToken,
            "method": method
        };
    };

    this.isHostConnected = function(hostname) {
        return ($rootScope.managedAppliance.hostname === hostname);
    }
}]);

