angular.module('dynamicdashboardapp',['ui.dashboard'])

/* Factory class which inherit of WidgetDataModel from ui.dashboard module */
    .factory('RandomDataModel', function ($interval, WidgetDataModel){
        function RandomDataModel(){
        }

        RandomDataModel.prototype=Object.create(WidgetDataModel.prototype);
        RandomDataModel.prototype.constructor=WidgetDataModel;

        angular.extend(RandomDataModel.prototype,{
            init: function (){
                var dataModelOptions=this.dataModelOptions;
                this.limit=(dataModelOptions && dataModelOptions.limit) ? dataModelOptions.limit : 100;

                this.updateScope('-');
                this.startInterval();
            }
        });

        return RandomDataModel;
    })

    /* widgetDefinitions factory class.
     * Define all widget definitations
     */
    .factory('widgetDefinitions', function(RandomDataModel, $rootScope){
        return [
            {
                name: 'DAILY FEED',
                templateUrl: 'app/dynamic-dashboard/dailyfeed/dailyFeedWidget.html',
                style:{
                    width: '34%',
                    height:'300px',
                    "min-width":'30%',
                    "max-width":"98%"
                },
                isshow:false,
                disabled:false
            },
            {
                name: 'REMOTE APPLIANCE STATUS',
                templateUrl: 'app/dynamic-dashboard/networked-appliances/networked-appliances-tile.html',
                style:{
                    width: '98.5%',
                    height: '500px',
                    "min-height":'300px',
                    "max-height": '1200px',
                    "min-width":'60%'
                },
                isshow:true,
                disabled:!$rootScope.isNetworkManager,
                enableVerticalResize: true
            }
        ];
    })

    /* userWidgetPreferenceFactory factory class.
     * Define function to fetch user widget preference from backend.
     */
    .factory('userWidgetPreferenceFactory', function ($http){
        return{
            getUserWidgetPreference:function(url){
                var promise=$http({
                    url: url,
                    method: "get"
                })
                .catch(function(error) {
                    console.log("Error userWidgetPreferenceFactory");
                    console.log(error);
                });
                return promise;
            }
        }
    })

    /* modalDialog directive.
     * Define pop up dialog for configure widget when click configuration button.
     */
    .directive('modalDialog', function(){
        return{
            restrict: 'E',
            scope:{
                show: '='
            },
            replace: true, // Replace with the template below
            transclude: true, // we want to insert custom content inside the directive
            link: function(scope, element, attrs){
                scope.dialogStyle={};
                if (attrs.width)
                    scope.dialogStyle.width=attrs.width;
                if (attrs.height)
                    scope.dialogStyle.height=attrs.height;
                scope.hideModal=function(){
                    scope.show=false;
                };
            },
            template: "<div class='ng-modal' ng-show='show'><div class='ng-dashboardmodeldialog-dialog' ng-style='dialogStyle'><div class='ng-dashboardmodeldialog-dialog-content' ng-transclude></div></div></div>"
        };
    })

    /* Dynamic Dashboard Controller is main controller for dynamic dashboard. */
    .controller('DynamicDashboardController', function ($scope, $rootScope, $interval, $window, Page, widgetDefinitions, userWidgetPreferenceFactory,$http, ngDialog){
        /* scope variable defination */
        $rootScope.CheckFreeCE=false;
        $rootScope.tempdefaultwidget= widgetDefinitions;
        $scope.selected_widget=[];
        $scope.userWidgetPreference=[];
        $rootScope.isDropDownBoxShow=true;
        Page.setTitle('Overview');
        $rootScope.defaultUserPrefernce = function() {
            var jsonfileName = "defaultPortalWidgetPreference.json";
            var defaultUrl = "app/dynamic-dashboard/assets/data/" + jsonfileName;
            userWidgetPreferenceFactory.getUserWidgetPreference(defaultUrl).then(function (result) {
                $scope.dashboardOptions.removeAllTiles();
                $scope.userWidgetPreference = [];
                $scope.userWidgetPreference = result.data.data;
                $scope.saveUserPreference(result.data.data);
                $scope.$broadcast('defaultWidgetReadyEvent', $scope.userWidgetPreference);
            });
        };
        $scope.userPrefernce = function(){
            var jsonfileName= "defaultPortalWidgetPreference.json";
            var defaultUrl="app/dynamic-dashboard/assets/data/" +jsonfileName ;
            //$scope.defaultUserPrefernce();
            /* call function to fetch user widget preference list and set into dashboard */
            userWidgetPreferenceFactory.getUserWidgetPreference(defaultUrl).then(function(result){
                var url = '/portal/api/preferences.php?user=' + encodeURIComponent($rootScope.user.name);
                $http({
                    url: url,
                    method: 'get'
                }).then(function(data, status, headers){
                    var preferenceArray=[];
                    var arraylength=0;
                    var prefrenceObject={};
                    // console.log(data.data.preferences.dashboard_settings);
                    //console.log(typeof(data.data.preferences.dashboard_settings));
                    if(typeof(data.data.preferences.dashboard_settings) !== 'undefined'  && data.data.preferences.dashboard_settings !== ""){
                        prefrenceObject=JSON.parse(data.data.preferences.dashboard_settings);
                        // console.log(prefrenceObject.dashboard_prefrence);
                        preferenceArray=prefrenceObject.dashboard_prefrence;
                        arraylength=(preferenceArray instanceof Array) ? preferenceArray.length :0;
                    }
                    if (typeof(data.data.preferences.dashboard_settings) !== 'undefined' && data.data.preferences.dashboard_settings !==  "" && arraylength > 0){

                        for (var j =0 ; j< preferenceArray.length ; j++){
                            var prefName = preferenceArray[j].name;
                            // Prevent duplicates.
                            var existingWidgetName = _.find($scope.userWidgetPreference, function(obj, prefName) { return obj.name === prefName });
                            if (existingWidgetName === undefined) {
                                objWidget={};
                                objWidget.name=prefName;
                                objWidget.style=preferenceArray[j].containerStyle;
                                objWidget.isshow=true;
                                $scope.userWidgetPreference[j]=objWidget;
                            } else {
                                console.log("duplicate widget");
                            }
                        }
                    } else {
                        console.log('else');
                        for(var i=0; i < (result.data.data).length;i++){
                            var objWidget={};
                            objWidget.name=result.data.data[i].name;
                            objWidget.style=result.data.data[i].style;
                            objWidget.isshow=result.data.data[i].isshow;
                            $scope.userWidgetPreference.push(objWidget);
                        }
                    }
                    $scope.$broadcast('defaultWidgetReadyEvent',$scope.userWidgetPreference);
                }, function(data) {
                    // Reset preferences to the default.  Would be best to put up a warning tile, as this could be circular.
                    $rootScope.defaultUserPrefernce();
                })
            });
        };
        if ($scope.user.loggedIn) {
            $scope.userPrefernce();

        }

        /* Event listener for defaultWidgetReadyEvent. */
        $scope.$on('defaultWidgetReadyEvent', function (event, userWidgetPreference){
            /* reset of tempdefaultwidget Array isshow = false*/
            for (var k = 0; k < (($rootScope.tempdefaultwidget).length); k++) {
                $rootScope.tempdefaultwidget[k].isshow = false;
            }
            /* end of reseting of tempdefaultwidget */

            var tileErrors = 0;
            for(var i=0;i<userWidgetPreference.length;i++){
                try {
                    $scope.dashboardOptions.addWidget(userWidgetPreference[i], true);
                    $scope.selected_widget.push(userWidgetPreference[i]);

                    for (var j=0; j < (($rootScope.tempdefaultwidget).length); j++){
                        if (userWidgetPreference[i].name !== undefined  && $rootScope.tempdefaultwidget[j].name === userWidgetPreference[i].name){
                            $rootScope.tempdefaultwidget[j].isshow= userWidgetPreference[i].isshow;
                        }
                    }
                }
                catch (e) {
                    console.log("Dashboard Tile exception: ", e);
                    tileErrors++;
                }
            }
            if (tileErrors > 0) {
                // Reset preferences to the default.  Would be best to put up a warning tile, as this could be circular.
                $rootScope.defaultUserPrefernce();
            }
        });


        /* Set dashboard options and set as value of dashboard attribute in dashboard.html */
        $scope.dashboardOptions={
            widgetButtons: false,
            widgetDefinitions: $rootScope.tempdefaultwidget,
            defaultWidgets: $scope.userWidgetPreference,
            storage: $window.localStorage,
            storageId: 'explicitSave',
            explicitSave: true,  // false if want to store in local storage.
            enableHorizontalResize:true,
            enableVerticalResize:false
        };

        /* function to remove/add widgets on page based on check/uncheck in drop-down list */
        $scope.toggleSelection=function toggleSelection(widget){
            if(widget.isshow === false){
                if (!$scope.dashboardOptions.removeWidget(widget)) {
                    ngDialog.open({
                        dialogType:'error',
                        dialogMessage: 'You cannot remove all tiles from the dashboard.'
                    });
                    widget.isshow = true;
                    $scope.dashboardOptions.leaveWidget(widget);
                }
            }else if (widget.isshow === true){
                $scope.dashboardOptions.addWidget(widget, true);
                $scope.selected_widget.push(widget);
                $scope.saveUserPreference( $scope.selected_widget);
            }
        };
        $scope.saveUserPreference =function(widgets){
            var dataObject={};
            var url = '/portal/api/preferences.php?user=' + encodeURI($rootScope.user.name);
            $http({
                url: url,
                method: 'get'
            }).then(function(data, status, headers){
                if(typeof(data.data.preferences.dashboard_settings) !== 'undefined' && data.data.preferences.dashboard_settings !== ""){
                    var jsonUserPrefrence=JSON.parse(data.data.preferences.dashboard_settings);
                    if (jsonUserPrefrence instanceof Array){
                        data.data.preferences.dashboard_settings="";
                    }
                }
                var dashboardPrefrenceObject=(data.data.preferences.dashboard_settings !== undefined && data.data.preferences.dashboard_settings !== "" && data.data.preferences.dashboard_settings !== [])?JSON.parse(data.data.preferences.dashboard_settings):{dashboard_prefrence:[], report_preference:{}};
                dashboardPrefrenceObject["dashboard_prefrence"]=widgets;
                dataObject["dashboard_settings"]=JSON.stringify(dashboardPrefrenceObject);
                var urlPut = '/portal/api/preferences.php?user=' + encodeURI($rootScope.user.name);

                $http({
                    url: urlPut,
                    data: dataObject,
                    method: 'PUT'
                }).then(function(data, status, headers){

                }, function(response){
                    console.log(response);
                });
            })
        };

        $scope.$on('DashBoardPreferenceChanged', function (event, widget){
            $scope.saveUserPreference(widget);
            $scope.$broadcast('DashBoardPreferenceChangedEvent', widget);
        });

        /* Event listener of removeWidgetEvent */
        $scope.$on('removeWidgetEvent', function (event, widget){
            for (var i=0; i < (($rootScope.tempdefaultwidget).length); i++){
                if ( widget.name !== undefined  && $rootScope.tempdefaultwidget[i].name === widget.name){
                    $rootScope.tempdefaultwidget[i].isshow=false;
                    break;
                }
            }

            for (i=0; i < (($scope.selected_widget).length); i++){
                if ( widget.name !== undefined  && $scope.selected_widget[i].name === widget.name){
                    $scope.selected_widget[i].isshow=false;
                    $scope.selected_widget.splice(i, 1);
                    break;
                }
            }
        });

        /* click event function to animate widget list as slide down. */
        $('.selected-items-box').bind('click', function(e){
            e.stopPropagation();
            $('.multiple-select-wrapper .list').toggle('slideDown');
        });

        /* click event for widget list */
        $('.multiple-select-wrapper .list').bind('click', function(e){
            e.stopPropagation();
        });

        /* click event function to animate widget list as slide up. */
        $(document).bind('click', function(){
            $('.multiple-select-wrapper .list').slideUp();
        });

        /* function for selected items. */
        $scope.getSelectedItemsOnly=function(item){
            return item.selected;
        };
        $scope.$on('widgetResized', function (event, size) {
            $scope.width = size.width || $scope.width;
            $scope.height = size.height || $scope.height;
        });

        /* Function for to get summary count for dashboard tile tooltip*/
        $scope.getSummaryCount = function(widget){
            var url ="/api/summary/counts";
            $scope.lastUpdatedText = "  Loading..." // This is temporary Place holder API. It will change later once will get acual API
            var count = 0;
            $http({
                method: 'get',
                url   : url
            }).then(function(data, status, headers) {
                count = data.last_updated;
                var date = new Date(count);
                var milliseconds = date.getTime();
                var revised_millisecond = milliseconds + 2700000;
                var revised_date = new Date(revised_millisecond);
                $scope.lastUpdatedText = (count===undefined||count===null)?"Not Defined":count;
                $scope.lastUpdatedToolTipText = (count===undefined||count===null)?"Not Defined":revised_date.toString();
                $scope.toolTipText =" Counts are updated hourly by default. Manually running updates can take an extended period of time.";
            }, function(response) {
                ngDialog.open({
                    dialogType:'retry',
                    dialogMessage:response.result[0].message
                })
            });

        }
        /* Function for refresh count matrices*/
        $scope.refreshCountMatrices = function(widgetName){
            var IdStr = "refreshCountTooltipId"+widgetName;
            var widgetID =  "[id='"+IdStr+"']";
            $(widgetID).find(".highlight-identifier").removeClass("span-color-dark");
            $(widgetID).find(".highlight-identifier").addClass("span-color");

            var url ="/api/summary/counts"; // This is temporary Place holder API. It will change later once will get acual API
            var tempObj ={time_updated:$scope.lastUpdatedText};
            $http({
                method: 'put',
                url   : url,
                data  : tempObj
            }).then(function(data, status, headers) {
                $(widgetID).find( ".highlight-identifier" ).addClass("span-color-dark");
                $(widgetID).find( ".highlight-identifier" ).removeClass("span-color");
            }, function(response) {
                ngDialog.open({
                    dialogType:'retry',
                    dialogMessage:response.result[0].message
                })
            });
        }

    })