var helpApp = angular.module('help', ['ngDialog']);

helpApp.factory('helpFactory', function($http) {
    return {
        async: function(url, extra_params, callback) {
            var params = {};
            params.ts = Date.now();
            if (extra_params != null) {
                params = $.extend(params, extra_params);
            }
            var promise = $http({
                url: url,
                method: "get",
                params: params
            }).then(function(data) {
                console.log("success");
            }, function(){
                window.PHD.throwError({"result": [{"message": gettext("Cannot load help information.")}]});
                //PHD.hideLoadingIndicator(load);
            });  //1. this returns promise
            return promise;
        }
    };
});


helpApp.controller('HelpCtrl', ['$scope', '$rootScope', '$http', '$route', '$window', 'helpFactory', 'ngDialog',
    function($scope, $rootScope, $http, $route, $window, helpFactory, ngDialog) {

        // Help functions, specific variables.

        $scope.getSupportURL = function() {
            return "http://www.unitrends.com/support";
        };

        $scope.getOnlineHelpURL = function() {
            var url = "https://unitrends-support.force.com/";
            var free_article = "UnitrendsFree/s/article/";
            if ($rootScope.isGoogle) {
                url += free_article + "000003715";
            } else {
                url += "UnitrendsBackup/s/";
            }
            return url;

        };

        $scope.getKnowledgeBaseURL = function() {
            return $rootScope.isCE ? "https://unitrends-support.force.com/UnitrendsFree" : "http://www.unitrends.com/support/knowledge-base";
        };

        $scope.getFeedbackURL = function(){
            return FEEDBACK_URL + "/topic/0TO40000000PMPcGAO/Product Ideas";
        };

        $scope.getTourURL = function() {
            return "#";
        };
        $scope.startTour = function() {
            $scope.user.showTour = true;
            var loc = $window.location.href;
            // redirect to main page if not there already.
            if (!loc.match(/#\/$/)) {
                $window.location.href = "#";
            }
            $route.reload();
        };

        function displayAbout(data) {
            $scope.appliance = data.appliance;
            
            $scope.appliance.browser_info = bowser.ua;
            $scope.appliance.browser_name = bowser.chrome ? "Chrome" :
                                            bowser.msie ? "Internet Explorer" :
                                            bowser.msedge ? "Microsoft Edge" :
                                            bowser.firefox ? "Firefox" : "Other/Unknown";
            $scope.appliance.browser_resolution = screen.width + " x " + screen.height;
            
            ngDialog.open({
                template: 'app/help/about.html',
                scope: $scope,
                overlay:true,
                ngDialogStyle:'width:425px'
            });
        }

        $scope.runAbout = function() {
            var appliance = { 'name': 'portal', 'version': 1.0 };
            var data = { 'appliance': appliance };
            displayAbout(data);
        };
    }]

);
